-- MonLogiciel.applescript

--  Created by Alain Le Gallou on 10/12/07.  v0.104
-- Support du tutoriel décrit à http://www.legallou.com/Mac/ASS/ASSindex.html

global notesDataSource -- Data Source référence 
global cancel
global OK

property nomFichierPlist : "com.legallou.MonLogiciel.plist"
property dossierRacine : missing value -- Chemin d'accès à l'application 
property cheminBibliothequePreferenceUtilisateur : missing value -- "iMac:Users:alg:Library:Preferences:"
property nomDuFichierPlistPreferenceUtilisateur : missing value --"iMac:Users:alg:Library:Preferences:com.legallou.MonLogiciel.plist"



on awake from nib theObject --------------------------------------
	
	if the name of theObject is "Main" then
		log "Main"
		-- Initialisation pour la localisation
		set cancel to localized string "Cancel" from table "Localizable"
		set OK to localized string "OK" from table "Localizable"
		
		laPlistExistelle() --Vérification si la P-list existe dans les préférences utilisateur
		
		load_Notes() -- Chargement de toutes les notes		
		--hide window "Input"
		--Notes_Init_Data() -- pour debugging et démonstration	
	end if
	
end awake from nib --------------------------------------




on clicked theObject --------------------------------------
	
	-- Icône "New Note" in Toolbar
	if name of theObject is "TBNouvelleNote" then
		log "TBNouvelleNote"
		if (the option key down of event 1 is true) then
			-- Ajout d'une ligne direct		
			set leNom to "leNom"
			set laDescription to "laDescription"
			set laDate to (current date) as date
			set lePrix to 123 as number
			set laCol5 to ""
			set LaCol6 to ""
			
			stockerUneLigne(leNom, laDescription, laDate, lePrix, laCol5, LaCol6)
		else
			routine_AddOneNote() -- Appel normal de la fenêtre "Input"
		end if
	end if
	
	-- Icône "Delete Note" in Toolbar
	if name of theObject is "TBSupprimerNote" then routine_DeleteNote()
	
	
	
	
	-- Les deux boutons de la fenêtre "Input"
	if (the name of theObject is "AjouterInput") then routine_AjouterInput()
	if (the name of theObject is "CancelInput") then hide window "Input"
	
	
	
	
	-- Suppression d'une rangée sélectionnée si la touche option est enfonçée 
	if (the name of theObject is "notesTableView") then
		
		if (the option key down of event 1 is true) then
			
			set notesTablePointeur to table view "notesTableView" of scroll view "notesScrollView" of window "Main"
			-- Le résultat est "table view id 4 of scroll view id 3 of window id 1"
			
			set selectedDataRows to selected data rows of notesTablePointeur
			-- Le résultat est "{data row id 19 of data source id 12}"
			
			if (count of selectedDataRows) > 0 then
				
				delete (item 1 of selectedDataRows) -- item 1 obligatoire c'est une liste				
			end if
		end if
	end if -----------------------------------------
	
end clicked --------------------------------------



on choose menu item theObject -------------- Gére la barre des Menus --------------------
	
	log "choose menu item"
	
	if name of theObject is "Importer" then routine_Importer()
	
	if name of theObject is "Exporter" then routine_Exporter()
	
	if name of theObject is "Ajouter une ligne" then routine_AddOneNote()
	
	if name of theObject is "Suppression de lignes" then routine_DeleteNote()
	
	
end choose menu item ----------------------------------------------------




on should quit theObject --- Exécuté à la fermeture de  l'application -----
	log "should quit"
	stockerAllNotesInPlist() -- Ecriture de la data source "Notes" dans l'entrée "NotesToutes" de la P-list 	
end should quit ---------------------------------------------------





on column clicked theObject table column tableColumn -------------------------
	--TRI d'une colonne avec inversion de ascending descending ---
	-- Tri de celle qui a été cliquée - programme standard Apple
	-- Voir AppleScript Studio exemple dans "table sort"
	
	-- Obtention de la data source du tableau
	set theDataSource to data source of theObject
	
	-- Obtention de l'identifiant de la colonne cliquée
	set theColumnIdentifier to identifier of tableColumn
	
	-- Quelle est la colonne de tri actuelle dans la data source
	set theSortColumn to sort column of theDataSource
	
	-- Si la colonne de tri n'est pas celle cliquée, inverser les colonnes
	if (name of theSortColumn) is not equal to theColumnIdentifier then
		set the sort column of theDataSource to data column theColumnIdentifier of theDataSource
	else
		-- Changement de l'ordre du tri
		if sort order of theSortColumn is ascending then
			set sort order of theSortColumn to descending
		else
			set sort order of theSortColumn to ascending
		end if
	end if
	
	-- Pour redessiner le tableau executer la commande update
	update theObject
	
	set selected rows of theObject to {0} -- Pour enlever le fond bleue 
	
end column clicked ---------------------------------------------------


(* ===================  La P-list existe-t-elle  =================== *)

on laPlistExistelle()
	--plist Initialisation : Vérification si la P-list existe dans les préférences utilisateur
	-- Elle n'existe pas à la première exécution de l'application --> création
	log "laPlistExistelle"
	set dossierRacine to ((POSIX file (resource path of main bundle)) as string) & ":"
	log "dossierRacine= " & dossierRacine
	-- Résultat : "iMac:Users:alg:Documents:ASSdev:xCodeRésultat:Debug:MonLogiciel.app:Contents:Resources:"
	
	set NomFichierPlistDuBundle to dossierRacine & nomFichierPlist
	log "NomFichierPlistDuBundle= " & NomFichierPlistDuBundle
	-- Résultat : "iMac:Users:alg:Documents:ASSdev:xCodeRésultat:Debug:MonLogiciel.app:Contents:Resources:com.legallou.MonLogiciel.plist"
	
	set cheminBibliothequePreferenceUtilisateur to ((path to preferences folder from user domain) as string)
	set nomDuFichierPlistPreferenceUtilisateur to cheminBibliothequePreferenceUtilisateur & nomFichierPlist
	log "nomDuFichierPlistPreferenceUtilisateur= " & nomDuFichierPlistPreferenceUtilisateur
	-- Résultat : "iMac:Users:alg:Library:Preferences:com.legallou.MonLogiciel.plist"
	
	if fileExists(NomFichierPlistDuBundle) then -- P-list du bundle
		if fileExists(nomDuFichierPlistPreferenceUtilisateur) then -- P-list de la bibliothéque utilisateur
			log "P-list in user library - allready exists." -- Rien à faire
		else
			log "P-list in user library  - doesn't exists."
			-- Copie de la P-list du bundle dans la bibliothéque utilisateur
			tell application "Finder" to duplicate (NomFichierPlistDuBundle as alias) to folder cheminBibliothequePreferenceUtilisateur
		end if
	else
		-- display dialog "ERREUR,  la P-list n'existe pas dans le Bundle"
		set monMessage to localized string "PlistNotFound" from table "Localizable"
		display dialog monMessage buttons {cancel, OK} default button 2
	end if
end laPlistExistelle

on fileExists(file_name)
	tell application "Finder" to return exists file file_name
end fileExists

(* ==================================================== *)




(* ==== Gestion du tableau "Notes" initialisation, data source création ====== *)



on load_Notes() ----------------------------------------------------------------------------
	-----  Chargement à partir de la p-list "com.legallou.MonLogiciel.plist" ------   	
	log "load_Notes"
	tell user defaults
		set ListeDeToutesLesNotes to contents of default entry "NotesToutes" as list
	end tell
	Creation_DataSource_Notes(ListeDeToutesLesNotes) -- Create & load Data Source
	
end load_Notes ----------------------------------------------------------------------------




on Creation_DataSource_Notes(la_liste) --------- création de la data source et initialisation -----------
	log "Creation_DataSource_Notes"
	-- Nous allons définir une "data source" pour stocker en mémoire RAM les données du tableau --
	-- En premier, nous définissons un pointeur sur l'objet tableau sur lequel nous allons travailler --
	set NotesObject to table view "notesTableView" of scroll view "notesScrollView" of window "Main"
	
	-- Maintenant nous définissons une "data source" associée à ce tableau --
	-- elle sera ajouter au autre data source déjà existante --
	-- On lui donne un nom pour la gestion interne --
	set notesDataSource to make new data source at end of data sources with properties {name:"notesDS"}
	
	-- Création des colonnes de données, incluant l'information de tri pour chaque colonne --
	make new data column at end of data columns of notesDataSource with properties {name:"Name", sort order:ascending, sort type:alphabetical, sort case sensitivity:case insensitive}
	make new data column at end of data columns of notesDataSource with properties {name:"Description", sort order:ascending, sort type:alphabetical, sort case sensitivity:case insensitive}
	make new data column at end of data columns of notesDataSource with properties {name:"Date", sort order:ascending, sort type:alphabetical, sort case sensitivity:case sensitive}
	make new data column at end of data columns of notesDataSource with properties {name:"Prix", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
	make new data column at end of data columns of notesDataSource with properties {name:"Col5", sort order:ascending, sort type:alphabetical, sort case sensitivity:case insensitive}
	make new data column at end of data columns of notesDataSource with properties {name:"Col6", sort order:ascending, sort type:alphabetical, sort case sensitivity:case insensitive}
	
	-- Précisons que nous voulons trier les colonnes
	set sorted of notesDataSource to true -- La "data source" est triée
	
	-- Définition de la colonne de tri initiale --
	set sort column of notesDataSource to data column "Name" of notesDataSource
	
	-- Finallement, relions la "data source" au tableau --
	set data source of NotesObject to notesDataSource -- tableau "notesTableView"
	
	-- Stockage, par remplacement, des données dans la data source --
	append notesDataSource with la_liste
	
end Creation_DataSource_Notes ----------------------------------------------






on stockerAllNotesInPlist() ---- Ecriture de la data source "Notes" dans l'entrée "NotesToutes" de la P-list  
	log "stockerAllNotesInPlist"
	---- Récupérons les données du tableau (Data Source) -----	
	set mesNotes to content of contents of notesDataSource as list -- Les données
	
	tell user defaults
		--  Création une entrée dans de la p-list, si elle n'existe pas elle sera créée 
		-- Si elle existe déjà la commande ne génére pas d'erreur
		make new default entry at end of default entries with properties {name:"NotesToutes", contents:mesNotes}
		
		-- Stockage des données dans la p-list
		set contents of default entry "NotesToutes" to mesNotes
	end tell
	
	return true
	
end stockerAllNotesInPlist -----------------------------------------------



(* ==================================================== *)






(* ==================== Handler généraux =================== *)


on stockerUneLigne(leNom, laDescription, laDate, lePrix, laCol5, LaCol6)
	
	log "stockerUneLigne" -- Trace pour la mise au point
	
	-- Initialiser une nouvelle rangée dans la data source
	set nouvelRange to make new data row at the end of the data rows of notesDataSource
	
	-- Transférer les données des champs vers la nouvelle rangée
	set contents of data cell "Name" of the nouvelRange to leNom
	set contents of data cell "Description" of the nouvelRange to laDescription
	set contents of data cell "Date" of the nouvelRange to laDate
	set contents of data cell "Prix" of the nouvelRange to lePrix as number
	set contents of data cell "Col5" of the nouvelRange to laCol5
	set contents of data cell "Col6" of the nouvelRange to LaCol6
	
	-- Ecriture dans la data source
	tell table view "notesTableView" of scroll view "notesScrollView" of the window "Main" to update
	
end stockerUneLigne ------------------------------------------------------------





on routine_DeleteNote() ------------- Suppression multiple -----------------	
	
	log "routine_DeleteNote"
	set notesTablePointeur to table view "notesTableView" of scroll view "notesScrollView" of window "Main"
	-- Le résultat "table view id 4 of scroll view id 3 of window id 1"
	
	set lesLignesSelectionner to selected data rows of notesTablePointeur
	-- Le résultat est la liste des adresses des lignes à supprimer --
	-- "{data row id 30 of data source id 12, data row id 31 of data source id 12}
	
	
	if (count of lesLignesSelectionner) > 0 then
		repeat with i from 1 to (count of lesLignesSelectionner)
			delete (item i of lesLignesSelectionner) --  c'est une liste
		end repeat
		set selected rows of notesTablePointeur to {0} -- Pour enlever le fond bleue
	else
		-- display dialog "Vous devez sélectionner au moins une rangée"
		set monMessage to localized string "YouMustSelectRows" from table "Localizable"
		display dialog monMessage buttons {cancel, OK} default button 2
		
	end if
end routine_DeleteNote ---------------------------------------------------





on routine_AddOneNote() --------- Ajout d'une Note - show window "Input" -------------
	-- Remise à blanc des champs d'entrées
	set the contents of text field "NomInput" of window "Input" to "theName"
	set the contents of text field "DescriptionInput" of window "Input" to "theDescription"
	set the contents of text field "DateInput" of window "Input" to current date
	set the contents of text field "PrixInput" of window "Input" to 12
	-- tell window "Input" to open - marche pas -
	show window "Input"
end routine_AddOneNote ---------------------------------------------------



on routine_AjouterInput() -------- Quand le bouton "ajouterInput" est cliqué --------
	set leNom to contents of text field "NomInput" of window "Input"
	set laDescription to contents of text field "DescriptionInput" of window "Input"
	set laDate to contents of text field "DateInput" of window "Input"
	set lePrix to contents of text field "PrixInput" of window "Input" as number
	set laCol5 to ""
	set LaCol6 to "" -- Pas dans la fenêtre INPUT
	
	stockerUneLigne(leNom, laDescription, laDate, lePrix, laCol5, LaCol6)
	
	-- Remise à blanc des champs d'entrées
	set the contents of text field "NomInput" of window "Input" to "theName"
	set the contents of text field "DescriptionInput" of window "Input" to "theDescription"
	set the contents of text field "DateInput" of window "Input" to current date
	set the contents of text field "PrixInput" of window "Input" to 14
	hide window "Input"
end routine_AjouterInput ---------------------------------------------------




------------------------ pop up de sélection d'un fichier ------------------------
on chooseFile() -- Résultat : iMac:Users:alg:dossier sélectionné
	set defaultFolder to getHomeSites()
	set withInvisibles to false
	set monFichier to (choose file with prompt "Choose Folder" default location defaultFolder without invisibles and multiple selections allowed)
	return monFichier
end chooseFile

on getHomeSites() -- Résultat : iMac:Users:alg:
	set sitesPath to do shell script "echo $HOME/"
	set sitesFolder to POSIX file sitesPath
	return sitesFolder --as alias
end getHomeSites ------------------------------------------------------------------------


(* ================================================ *)




(* ================ Importer & Exporter =================== *)

on routine_Importer() ---------------------------- Importer ----------------------------
	-- Saute les ligne vides (CR seul ) cas fréquent en fin de fichier
	-- Nombre de colonne variable de 1 à 6
	log "Importer"
	try
		set monFichier to chooseFile() -- Sélection du fichier à lire		
		--set monFichier to alias "iMac:Users:alg:Documents:ASSdev:InputNotes"
		open for access monFichier -- Le fichier doit exister, sinon il est créé vide
		read monFichier -- Lecture de la totalité du fichier
		set tout_le_fichier to the result
		close access monFichier -- Ne pas oublier de fermer le fichier				
	on error
		--display dialog "Erreur sur le fichier entrée" -- "ErrorInputFile" = "Erreur sur le fichier entrée";
		set monMessage to localized string "ErrorInputFile" from table "Localizable"
		display dialog monMessage buttons {cancel, OK} default button 2
		
		close access monFichier -- Ne pas oublier de fermer le fichier
	end try
	
	-- Création de la liste de toutes les lignes (Une ligne par élément)
	set AppleScript's text item delimiters to (ASCII character 13) -- Carriage Return
	set toutes_les_lignes to (every text item of tout_le_fichier) as list
	set AppleScript's text item delimiters to "" -- Retour à la valeur normale		
	set tout_le_fichier to "" -- récupération de l'espace mémoire
	
	
	-- Ligne par ligne extraction des éléments tabulées
	repeat with une_ligne in toutes_les_lignes
		-- Equivalent à "set Nb_de_lignes to (count of toutes_les_lignes)" + "repeat with i from 1 to Nb_de_lignes" + "set une_ligne to (item i of toutes_les_lignes)"
		
		-- Initialisation à blanc pour le suivant
		set leNom to ""
		set laDescription to ""
		set laDate to ""
		set lePrix to ""
		set laCol5 to ""
		set LaCol6 to ""
		
		-- Ligne par ligne extraction des éléments tabulées				
		set AppleScript's text item delimiters to tab -- Tabulation
		set mes_colonnes to (every text item of une_ligne) as list
		set AppleScript's text item delimiters to "" -- Retour à la valeur normale		
		
		set Nb_elements to (the count of mes_colonnes)
		
		-- Initialisation des colonnes du tableau dépendant du nombre de colonne
		if Nb_elements is equal to 1 then
			
			-- ici tester si un CR seul sinon c'est une ligne avec seulement un titre
			set Nb_char to the count of characters of item 1 of mes_colonnes
			
			-- Test d'une ligne vide (un CR seul en fin de fichier ou au milieu)
			if Nb_char is equal to 0 then -- Uniquement un CR
				--	Rien à faire, on saute cette ligne
				
			else -- Un Titre seul
				log "1 item"
				set leNom to item 1 of mes_colonnes
				set laDescription to ""
				set laDate to ""
				set lePrix to ""
				stockerUneLigne(leNom, laDescription, laDate, lePrix, laCol5, LaCol6) -- Stocker dans la Data Source
			end if
		end if
		
		if Nb_elements is equal to 2 then
			log "2 item"
			set leNom to item 1 of mes_colonnes
			set laDescription to item 2 of mes_colonnes
			set laDate to "" --date (item 3 of mes_colonnes) -- string --> date
			set lePrix to ""
			stockerUneLigne(leNom, laDescription, laDate, lePrix, laCol5, LaCol6) -- Stocker dans la Data Source
		end if
		
		if Nb_elements is equal to 3 then
			log "3 item"
			set leNom to item 1 of mes_colonnes
			set laDescription to item 2 of mes_colonnes
			set laDate to date (item 3 of mes_colonnes) -- string --> date
			set lePrix to ""
			stockerUneLigne(leNom, laDescription, laDate, lePrix, laCol5, LaCol6) -- Stocker dans la Data Source
		end if
		
		if Nb_elements is equal to 4 then
			log "4 item"
			set leNom to item 1 of mes_colonnes
			set laDescription to item 2 of mes_colonnes
			set laDate to date (item 3 of mes_colonnes) -- string --> date
			set lePrix to item 4 of mes_colonnes
			stockerUneLigne(leNom, laDescription, laDate, lePrix, laCol5, LaCol6) -- Stocker dans la Data Source
		end if
		
		if Nb_elements is equal to 5 then
			log "5 item"
			set leNom to item 1 of mes_colonnes
			set laDescription to item 2 of mes_colonnes
			set laDate to date (item 3 of mes_colonnes) -- string --> date
			set lePrix to item 4 of mes_colonnes
			set laCol5 to item 5 of mes_colonnes
			
			stockerUneLigne(leNom, laDescription, laDate, lePrix, laCol5, LaCol6) -- Stocker dans la Data Source
		end if
		
		if Nb_elements is equal to 6 then
			log "6 item"
			set leNom to item 1 of mes_colonnes
			set laDescription to item 2 of mes_colonnes
			set laDate to date (item 3 of mes_colonnes) -- string --> date
			set lePrix to item 4 of mes_colonnes
			set laCol5 to item 5 of mes_colonnes
			set LaCol6 to item 6 of mes_colonnes
			
			stockerUneLigne(leNom, laDescription, laDate, lePrix, laCol5, LaCol6) -- Stocker dans la Data Source
		end if
	end repeat
end routine_Importer --------------------------------




on routine_Exporter() ---------------------------- Exporter ----------------------------
	log "Exporter"
	-- En premier sauvegarde de toutes les notes dans la P-list
	stockerAllNotesInPlist() -- Ecriture de la Data Source "Notes" dans l'entrée "NotesToutes" de la P-list 
	
	--  Obtention de toutes les données en liste de record (identique à la P-list)
	set ListeDeToutesLesNotes to content of contents of notesDataSource as list
	set NbLines to (count of ListeDeToutesLesNotes)
	set dataFichierFinal to ""
	
	-- Création du fichier sortie avec 
	-- ajout d'une tabulation entre chaque élément de chaque ligne
	repeat with i from 1 to NbLines
		set une_ligne_record to item i of ListeDeToutesLesNotes -- Une ligne "record"
		-- Résultat --> {|Col5|:"c5", |Col6|:"c6", |Date|:date "mercredi 6 décembre 2006 0:00:00", |Prix|:29, |Description|:"FTP", |Name|:"Transmit"}
		-- Notez, l'ordre n'est pas celui de la data source
		
		set leNom to |Name| of une_ligne_record & tab
		set laDescription to |Description| of une_ligne_record & tab
		set laDate to |Date| of une_ligne_record & tab
		set lePrix to |Prix| of une_ligne_record & tab
		set laCol5 to |Col5| of une_ligne_record & tab
		set LaCol6 to |Col6| of une_ligne_record & return
		
		set lineWithTab to leNom & laDescription & laDate & lePrix & laCol5 & LaCol6
		
		set dataFichierFinal to dataFichierFinal & lineWithTab -- Cumul de toutes les lignes
	end repeat
	
	
	-- Fenêtre de choix du nom de fichier à écrire  (panel flottant)
	set nomPropose to "NotesAB BackUp ladate"
	set leResultat to display save panel in directory "NotesAB" with file name nomPropose
	
	if leResultat is 1 then -- SAVE = 1, CANCEL = 0
		
		set leNomDuFichier to POSIX file (path name of save panel) as string
		-- Résultat : "iMac:Users:alg:Documents:.."	
		
		try
			set monFichierExport to open for access file leNomDuFichier with write permission
			set eof of monFichierExport to 0 -- met le marqueur de fin de fichier à zéro
			-- ce qui "efface" le contenu , si le fichier existe déjà
			-- sinon écriture par dessus
			write dataFichierFinal to monFichierExport
			close access monFichierExport -- Ne pas oublier de fermer le fichier				
		on error
			
			--display dialog "Erreur sur le fichier sortie"
			set monMessage to localized string "ErrorOutputFile" from table "Localizable"
			display dialog monMessage buttons {cancel, OK} default button 2
			
			close access monFichierExport -- Ne pas oublier de fermer le fichier
		end try
		
		set dataFichierFinal to "" -- Libérer la mémoire
		set ListeDeToutesLesNotes to "" -- Libérer la mémoire
		
	end if
	
end routine_Exporter

(* ==================================================== *)




(* ================= For Debug or Initialisation ================== *)



on Notes_Init_Data() ------------- Pour la première exécution ---------------------
	
	----------------------------- Liste initiale pour la démo --------------------------
	set ListeDeDemo to {{"Transmit", "FTP", date "mercredi 6 décembre 2006 0:00:00", 29, 95}, {"CDpedia", "Gestionnaire de CD", date "jeudi 11 octobre 2007 0:00:00", 16}, {"Coda", "Editeur de CSS & HTML", date "vendredi 7 décembre 2007 0:00:00", 69}}
	
	Creation_DataSource_Notes(ListeDeDemo) -- Create & load Data Source
	
	-- Notez pour la date, c'est xCode qui traduit 6/12/2006 en date longue
	-- La frappe initiale est {"Transmit", "FTP", date "6/12/2006", 29, 95}
	
end Notes_Init_Data ----------------------------------------------------------------------

(* ====================================================== *)
